#ifndef bqt_kbd_hh
#define bqt_kbd_hh

#include <string>
#include "events.hh"

/*
	Available keys (in addition to characters):
*/
enum bqt_keys
{
	BQT_KEY_F1 = 0x201,
	BQT_KEY_F2,
	BQT_KEY_F3,
	BQT_KEY_F4,
	BQT_KEY_F5,
	BQT_KEY_F6,
	BQT_KEY_F7,
	BQT_KEY_F8,
	BQT_KEY_F9,
	BQT_KEY_F10,
	BQT_KEY_F11,
	BQT_KEY_F12,
	BQT_KEY_TAB = 0x1000,
	BQT_KEY_BACKSPACE,
	BQT_KEY_ENTER,
	BQT_KEY_PRNSCR,
	BQT_KEY_PAUSE,
	BQT_KEY_INSERT,
	BQT_KEY_HOME,
	BQT_KEY_PGUP,
	BQT_KEY_DELETE,
	BQT_KEY_END,
	BQT_KEY_PGDN,
	BQT_KEY_UP,
	BQT_KEY_DN,
	BQT_KEY_LT,
	BQT_KEY_RT,
	BQT_KEY_ESC,
	BQT_SHIFT=0x2001,
	BQT_CTRL=0x2002,
};

class event_key : public eventdata
{
public:
	int key;      /* contains enum bqt_keys or a char */
	string ch;    /* as it would be in key buffer, esc[A etc */
	bool alt;
	bool ctrl;
	bool shift;
	
	event_key() : key(0), alt(false), ctrl(false), shift(false)
	{
	}
	event_key(const string &str, bqt_keys k, int flags=0) : key(k), ch(str), alt(false), ctrl(false), shift(false)
	{
		if(flags==BQT_SHIFT)shift=true;
		if(flags==BQT_CTRL)ctrl=true;
	}
};

extern event getkeyevent(unsigned mstowait);

#endif
